                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*   version 6: partial evaluation   */
                     /*-----------------------------------*/
                     /*            dictionary             */
                     /*-----------------------------------*/

#include <stdio.h>

#include "SlipMain.h"

#include "SlipDictionary.h"

/*------------------------------ private constants ---------------------------*/

static const TXT_type VNF_error_string = "variable not found";

/*------------------------------ public variables ----------------------------*/

ENV_type Dictionary_Environment;

/*------------------------------ public functions ----------------------------*/

ENV_type Dictionary_Bind(SYM_type Variable,
                         EXP_type Value,
                         ENV_type Environment)
  { ENV_type environment;
    environment = make_ENV(Variable,
                           Value,
                           Environment);
    return environment; }

NIL_type Dictionary_Define(SYM_type Variable,
                           EXP_type Value)
  { Dictionary_Environment = make_ENV(Variable,
                                      Value,
                                      Dictionary_Environment); }

NIL_type Dictionary_Initialize(NIL_type)
  { Dictionary_Environment = Main_Empty_Environment; }

EXP_type Dictionary_Lookup(SYM_type Variable)
  { ENV_type environment;
    for (environment = Dictionary_Environment;
         !is_NUL(environment);
         environment = environment->env)
      if (environment->var == Variable)
        return environment->val;
    Main_Error_Symbol(VNF_error_string,
                      Variable);
    return Main_Null; }

NIL_type Dictionary_Replace(SYM_type Variable,
                            EXP_type Value)
  { ENV_type environment;
    for (environment = Dictionary_Environment;
         !is_NUL(environment);
         environment = environment->env)
      if (environment->var == Variable)
        { environment->val = Value;
          return; }
    Main_Error_Symbol(VNF_error_string,
                      Variable); }